#ifndef FINGERTECH_H
#define FINGERTECH_H

#include <iostream>
#include <string>
#include <cstring>
#include "include/NBioAPI.h"
#include "include/NBioAPI_IndexSearch.h"
#include "include/NBioAPI_Export.h"
#include "include/NBioAPI_ExportType.h"
#include <stdio.h>
#include <unistd.h>
#include <fstream>  // ifstream
#include <stdlib.h> // atoi(), itoa()
#include <sstream>
using namespace std;

class Fingertech 
{
	NBioAPI_HANDLE          m_hNBioBSP;
	NBioAPI_FIR_HANDLE      m_hCapturedFIR;
	NBioAPI_DEVICE_INFO_0   m_DeviceInfo;
	bool                    m_bIsCapture;
    bool                    m_bStopFlag;
    NBioAPI_EXPORT_DATA     m_ExportData;
    NBioAPI_UINT8*          m_pTemplate;
    NBioAPI_UINT32          m_nLen;
    NBioAPI_INPUT_FIR       inputFIR_imported;
    NBioAPI_FIR_TEXTENCODE  textFirImported;
public:
    Fingertech();
    Fingertech(int);
    // Destrutor.
    ~Fingertech();
    void InitNBSPSDK();
	NBioAPI_RETURN SetDeviceList();
	NBioAPI_RETURN OpenDevice();
	NBioAPI_RETURN Capture(int);
	NBioAPI_RETURN Grava_fir(int, string, string);
    void Compara_fir_gravado(int, string, string);
    void Compara_dois_fir(string, string, string);
    void Compara_varios_fir(int, string, string);
    void Adiciona_fir_bd(string, int);
    void Checa_dedo_no_leitor(string);
    void TerminateNBSPSDK();
    void Export_Fir(int);
    void Save_Exported(string, string);
    void Load_Imported(string, string);
    void Import_Fir();
	bool Match(string, string);
	bool Registra_Digital(int);
	bool Identifica_Digital();
	NBioAPI_RETURN MyCallBackFun(NBioAPI_INDEXSEARCH_CALLBACK_PARAM_PTR_0);
	void Grava_arquivo(string, string);
	string Ler_arquivo(string);

};

#endif 
