# -*- coding: iso-8859-1 -*-
from SigUtils import formatastring
from datetime import datetime


__Autor__ = "Luiz Fernando"
__Empresa__ = "Sig Informatica Ltda"
__Site__ = "http://www.siginformatica.com.br"
__Versao__ = "1.12"
__DataAlteracao__ = "05/11/2013"
import sys

if __name__ == '__main__':
    try:
        if sys.argv[1] == '-9':
            print(('datas.py\t\tVersao:' + __Versao__ + '\tData:' + __DataAlteracao__) +
                  '\tValidacao e tratamento de datas')
        else:
            print(('\n\ndatas.py - Validacao e tratamento de datas \n' + 'Versao: ' + __Versao__ +
                   '\n' + 'Data: ' + __DataAlteracao__ + '\n'))
    except:
        print(('\n\ndatas.py - Validacao e tratamento de datas \n' + 'Versao: ' + __Versao__ +
               '\n' + 'Data: ' + __DataAlteracao__ + '\n'))

from calendar import monthrange
from datetime import date
from datetime import datetime


class sigDatas:
    """ classe para tratar datas
       Valida a data no formato AAAAMMDD, DDMMAAAA, AAAA/MM/DD, DD/MM/AAAA
       o intervado aceito vai do ano  1900 a 2500
       Se a classe nao conseguir identificar o formato, considerara o padrao AAAAMMDD
       Qdo houver erro, retorna -1
                        """

    def __iniciaVariaveis(self):
        self.ano = 0
        self.mes = 0
        self.dia = 0
        self.diasDoAno = 0
        self.totalDias = 0
        self.diaDaSemana = ""
        self.dia3DaSemana = ""
        self.nroDiaDaSemana = 0
        self.nroDiaDaDezena = 0
        self.nroDiaDaQuinzena = 0
        self.nomeDoMes = ""
        self.nome3DoMes = ""
        self.dataOk = False

    def getUltimoDiaDaQuinzena(self, mes=0):
        """Retorna o ultimo dia da quinzena da data instanciada
          Se o mes for informado, acha o ultimo dia da quinzena do mes informado,
             caso contrario da data instanciada
                              """
        if self.codErro != 0:
            return -1
        ultimoDiaMes = {1: 31, 2: 28, 3: 31, 4: 30, 5: 31, 6: 30, 7: 31, 8: 31, 9: 30, 10: 31, 11: 30, 12: 31}
        try:
            if mes != 0:
                mesTeste = int(mes)
            else:
                mesTeste = self.mes
            ultimoDia = ultimoDiaMes[mesTeste]
        except:
            self.codErro = 3 # mes invalido
            self.__iniciaVariaveis()
            return -1
        try:
            if mesTeste == 2:
                x = int(int(self.ano) / 4)
                x = x * 4
                if x == self.ano:
                    ultimoDia = 29
        except:
            self.codErro = 2 # ano invalido
            self.__iniciaVariaveis()
            return -1
        if int(ultimoDia) < 16:
            return 15
        else:
            ultimoDia = int(ultimoDia) - 15
        return int(ultimoDia)

    def getUltimoDiaDoMes(self, mes=0):
        """Retorna o ultimo dia do mes da data instanciada
          Se o mes for informado, acha o ultimo dia do mes informado, 
             caso contrario da data instanciada
                              """
        if self.codErro != 0:
            return -1
        ultimoDiaMes = {1: 31, 2: 28, 3: 31, 4: 30, 5: 31, 6: 30, 7: 31, 8: 31, 9: 30, 10: 31, 11: 30, 12: 31}
        try:
            if mes != 0:
                mesTeste = int(mes)
            else:
                mesTeste = self.mes
            ultimoDia = ultimoDiaMes[mesTeste]
        except:
            self.codErro = 3 # mes invalido
            self.__iniciaVariaveis()
            return -1
        try:
            if mesTeste == 2:
                x = int(int(self.ano) / 4)
                x = x * 4
                if x == self.ano:
                    ultimoDia = 29
        except:
            self.codErro = 2 # ano invalido
            self.__iniciaVariaveis()
            return -1
        return int(ultimoDia)

    def __testaAno(self):
        try:
            self.ano = int(self.data[:4])
        except:
            self.codErro = 2  # ano invalido
            self.__iniciaVariaveis()
            return -1

    def __testaMes(self):
        try:
            self.mes = int(self.data[4:6])
            if self.mes < 1 or self.mes > 12:
                self.codErro = 3
                self.__iniciaVariaveis()
                return -1
        except:
            self.codErro = 3
            self.__iniciaVariaveis()
            return -1

    def __testaDia(self):
        ultimoDia = self.getUltimoDiaDoMes()
        if ultimoDia == -1:
            self.__iniciaVariaveis()
            return -1
        try:
            self.dia = int(self.data[6:])
            if self.dia < 1 or self.dia > ultimoDia:
                self.__iniciaVariaveis()
                self.codErro = 4
                return -1
        except:
            self.__iniciaVariaveis()
            self.codErro = 4
            return -1

    def __testaFomatoData(self):
        # testar formato
        def __tstFM(ano, mes, dia):
            if ano > 1899 and ano < 2499:
                if mes > 0 and mes < 13:
                    if dia > 0 and dia < 32:
                        ano = formatastring.formataString(str(ano), 4, '0', 'E')
                        mes = formatastring.formataString(str(mes), 2, '0', 'E')
                        dia = formatastring.formataString(str(dia), 2, '0', 'E')
                        self.data = str(ano + mes + dia)
                        return True
            return False

        if len(self.data) == 8:
            # testa formata AAAAMMDD
            try:
                ano = int(self.data[:4])
                mes = int(self.data[4:6])
                dia = int(self.data[-2:])
                if __tstFM(ano, mes, dia):
                    return
            except:
                pass
                # testa formata DDMMAAAA
            try:
                dia = int(self.data[:2])
                mes = int(self.data[2:4])
                ano = int(self.data[-4:])
                if __tstFM(ano, mes, dia):
                    return
            except:
                pass
        else:
            # testa formata AAAA/MM/DD
            try:
                ano = int(self.data[:4])
                mes = int(self.data[5:7])
                dia = int(self.data[-2:])
                if __tstFM(ano, mes, dia):
                    return
            except:
                pass
                # testa formata DD/MM/AAAA
            try:
                dia = int(self.data[:2])
                mes = int(self.data[3:5])
                ano = int(self.data[-4:])
                if __tstFM(ano, mes, dia):
                    return
            except:
                pass

    def __testaData(self):
        self.__testaFomatoData()
        if self.data == '' or self.data == '00000000' or len(self.data) != 8:
            self.__iniciaVariaveis()
            self.codErro = 1
            return -1.
            # Testa se data e' verdadeira ****************************
        if self.__testaAno() == -1:
            return -1
        if self.__testaMes() == -1:
            return -1
        if self.__testaDia() == -1:
            return -1
        self.dataOk = True
        # Calcula dia do ano desde janeiro *************************
        totalDeDias = 0
        for x in range(self.mes - 1):
            ultimoDia = self.getUltimoDiaDoMes(x + 1)
            totalDeDias = totalDeDias + ultimoDia
        self.diasDoAno = totalDeDias + self.dia

        # Calcula total de dias desde dia primeiro do mes janeiro do ano 0000******************************
        self.totalDias = ((self.ano - 1) * 365) + int(((self.ano - 1) / 4)) + self.diasDoAno

        # Calcula o nome do mes ******************************************
        nomeMeses = {1: 'Janeiro', 2: 'Fevereiro', 3: 'Maro', 4: 'Abril', 5: 'Maio', 6: 'Junho',
                     7: 'Julho', 8: 'Agosto', 9: 'Setembro', 10: 'Outubro', 11: 'Novembro', 12: 'Dezembro'}
        self.nomeDoMes = nomeMeses[self.mes]
        self.nome3DoMes = self.nomeDoMes[:3]

        # Calcula o dia da semana ****************************************
        nomeDiaDaSemana = {1: 'Domingo', 2: 'Segunda', 3: 'Tera', 4: 'Quarta', 5: 'Quinta', 6: 'Sexta', 7: 'Sabado'}
        x = self.totalDias - (int(self.totalDias / 7) * 7)
        if x == 0: x = 7
        self.nroDiaDaSemana = x
        self.diaDaSemana = nomeDiaDaSemana[x]
        self.dia3DaSemana = self.diaDaSemana[:3]
        x = self.totalDias - (int(self.totalDias / 107) * 7)

        # Calcula o dia da Dezena ****************************************
        if self.dia < 10:
            self.nroDiaDaDezena = self.dia
        else:
            if self.dia < 20:
                self.nroDiaDaDezena = self.dia - 10
            else:
                self.nroDiaDaDezena = self.dia - 20

        # Calcula o dia da Quinzena ****************************************
        if self.dia < 15:
            self.nroDiaDaQuinzena = self.dia
        else:
            self.nroDiaDaQuinzena = self.dia - 15
        if self.nroDiaDaQuinzena > self.getUltimoDiaDaQuinzena():
            self.nroDiaDaQuinzena = self.getUltimoDiaDaQuinzena()

    def __init__(self, data):
        self.codErro = 0
        self.listaDeErros = (
            "vazio", # 0
            "Data Invalida", # 1
            "Ano invalido!", # 2
            "Mes invalido!", # 3
            "Dia invalido!", # 4
            "Tipo de prazo invalido!", # 5
            "prazo invalido!        ", # 6
            "Formato especificado invalido!", # 7
            "comBarras especificado invalido!", # 8
            "Dia de fechamento invalido!", # 9
            "vazio")
        self.data = str(data)
        self.__iniciaVariaveis()
        self.__testaData()


    def __calculoDD(self):
        return self.totalDias

    def __calculoDFS(self):
        dia = self.dia + (7 - self.nroDiaDaSemana)
        return self.totalDias - self.dia + dia

    def __calculoDFD(self):
        ultimoDiaDoMes = self.getUltimoDiaDoMes()
        lista = [10, 20, ultimoDiaDoMes]
        x = 0
        while lista[x] < self.dia:
            x = x + 1
        dia = lista[x]
        return self.totalDias - self.dia + dia

    def __calculoDFQ(self):
        ultimoDiaDoMes = self.getUltimoDiaDoMes()
        lista = [15, ultimoDiaDoMes]
        x = 0
        while lista[x] < self.dia:
            x = x + 1
        dia = lista[x]
        return self.totalDias - self.dia + dia

    def __calculoDFM(self):
        ultimoDiaDoMes = self.getUltimoDiaDoMes()
        return self.totalDias - self.dia + ultimoDiaDoMes

    def getDataNoFormato(self, formato='N', comBarras='N', separador='/'):
        """ Retorna a data no formato N=Normal (dd/mm/aaaa), I=Invertido(aaaa/mm/dd), D=Date
           comBarras deve ser S=Sim, N=Nao, outro caracter que especificara a separacao.
           obs: o outro caracter para separacao deve ter tamanho de 1 byte
                                     """
        if self.getDataOk() == '-1':
            return '-1'
        if formato not in ('N','I', 'D'):
            self.codErro = 7 # Formato invalido
            return '-1'
        if comBarras != 'N' and comBarras != 'S' and len(comBarras) != 1:
            self.codErro = 8 # comBarras invalido
            return '-1'
        ano = formatastring.formataString(str(self.ano), 4, '0', 'E')
        mes = formatastring.formataString(str(self.mes), 2, '0', 'E')
        dia = formatastring.formataString(str(self.dia), 2, '0', 'E')

        if formato == 'N':
            if comBarras == 'S':
                return dia + '/' + mes + '/' + ano
            else:
                if comBarras == 'N':
                    return dia + mes + ano
                else:
                    return dia + comBarras + mes + comBarras + ano
        elif formato == 'I':
            if comBarras == 'S':
                return ano + separador + mes + separador + dia
            else:
                if comBarras == 'N':
                    return ano + mes + dia
                else:
                    return ano + comBarras + mes + comBarras + dia
        else:
            _ds = '%s-%s-%s' % (ano, mes, dia)
            return datetime.strptime(_ds, '%Y-%m-%d').date()


    def getCalculaPrazo(self, prazo, tipoPrazo='DD', diasUteis='N', diaFechamento=0, feriados=[]):
        """ Calcula uma data de vencimento apartida da data instanciada
        @prazo, -> prazo em dias
        @tipoPrazo -> DD, DFS, DFD, DFQ, DFM, DU
        @diasUteis - S / N  -> informa se o vencimento em que ser em dias uteis
        @diaFechamento dia do fechamento para todos os tipos de prazo exceto DD
        @feriados -> lista da data dos feriados
        o formato de retorno eh AAAAMMDD
                                        """
        dicPrazo = {'DD': self.__calculoDD, 'DFS': self.__calculoDFS, 'DU': self.__calculoDD,
                    'DFD': self.__calculoDFD, 'DFQ': self.__calculoDFQ, 'DFM': self.__calculoDFM}
        sTipoPrazo = tipoPrazo.upper()
        try:
            valor = dicPrazo[sTipoPrazo]
        except:
            self.__iniciaVariaveis()
            self.codErro = 5 #tipo de prazo invalido
            return -1
        resultado = dicPrazo[sTipoPrazo]
        totalDias = resultado()
        if sTipoPrazo != 'DD':
            try:
                iDiaFechamento = int(diaFechamento)
                if iDiaFechamento == 0:
                    iDiaFechamento = 99
            except:
                self.__iniciaVariaveis()
                self.codErro = 9 # Dia de fechamento invalido
                return -1
            if sTipoPrazo == 'DU':
                import datetime
                data = date(int(self.data[:4]) ,int(self.data[4:6]), int(self.data[6:8]))
                cont_prazo = 1
                acrescimo_prazo = 0
                while cont_prazo <= prazo:
                    data_prazo = data + datetime.timedelta(days=cont_prazo)
                    if data_prazo.isoweekday() == 6 or data_prazo.isoweekday() == 7: # Se eh sabado ou domingo
                        prazo += 1
                        cont_prazo += 1
                        continue
                    if data_prazo.strftime('%Y-%m-%d') in feriados:
                        prazo += 1
                    cont_prazo += 1

            if sTipoPrazo == 'DFS':
                if iDiaFechamento > 7 and iDiaFechamento != 99:
                    self.__iniciaVariaveis()
                    self.codErro = 9 # Dia de fechamento invalido
                    return -1
                if self.nroDiaDaSemana > iDiaFechamento:
                    self.dia = self.dia + 7
                    _ultimoDiaDoMes = self.getUltimoDiaDoMes()
                    if self.dia > _ultimoDiaDoMes:
                        self.dia -= _ultimoDiaDoMes
                        self.mes += 1
                        if self.mes > 12:
                            self.mes = 1
                            self.ano += 1
                    _ano = str(self.ano)
                    _mes = str(self.mes)
                    _dia = str(self.dia)
                    if len(_mes) == 1:
                        _mes = '0' + _mes
                    if len(_dia) == 1:
                        _dia = '0' + _dia
                    self.data = _ano + '-' + _mes + '-' + _dia
                    self.__iniciaVariaveis()
                    self.__testaData()
                    totalDias = self.__calculoDFS()
            if sTipoPrazo == 'DFD':
                if iDiaFechamento > 10 and iDiaFechamento != 99:
                    self.__iniciaVariaveis()
                    self.codErro = 9 # Dia de fechamento invalido
                    return -1
                if self.nroDiaDaDezena > iDiaFechamento:
                    self.dia = self.dia + 10
                    _ultimoDiaDoMes = self.getUltimoDiaDoMes()
                    if self.dia > _ultimoDiaDoMes:
                        self.dia -= _ultimoDiaDoMes
                        self.mes += 1
                        if self.mes > 12:
                            self.mes = 1
                            self.ano += 1
                    _ano = str(self.ano)
                    _mes = str(self.mes)
                    _dia = str(self.dia)
                    if len(_mes) == 1:
                        _mes = '0' + _mes
                    if len(_dia) == 1:
                        _dia = '0' + _dia
                    self.data = _ano + '-' + _mes + '-' + _dia
                    self.__iniciaVariaveis()
                    self.__testaData()
                    totalDias = self.__calculoDFD()
            if sTipoPrazo == 'DFQ':
                if iDiaFechamento > 15 and iDiaFechamento != 99:
                    self.__iniciaVariaveis()
                    self.codErro = 9 # Dia de fechamento invalido
                    return -1
                if self.nroDiaDaQuinzena > iDiaFechamento:
                    self.dia = self.dia + 15
                    _ultimoDiaDoMes = self.getUltimoDiaDoMes()
                    if self.dia > _ultimoDiaDoMes:
                        self.dia -= _ultimoDiaDoMes
                        self.mes += 1
                        if self.mes > 12:
                            self.mes = 1
                            self.ano += 1
                    _ano = str(self.ano)
                    _mes = str(self.mes)
                    _dia = str(self.dia)
                    if len(_mes) == 1:
                        _mes = '0' + _mes
                    if len(_dia) == 1:
                        _dia = '0' + _dia
                    self.data = _ano + '-' + _mes + '-' + _dia
                    self.__iniciaVariaveis()
                    self.__testaData()
                    totalDias = self.__calculoDFQ()
            if sTipoPrazo == 'DFM':
                if iDiaFechamento > 30 and iDiaFechamento != 99:
                    self.__iniciaVariaveis()
                    self.codErro = 9 # Dia de fechamento invalido
                    return -1
                if self.dia > iDiaFechamento:
                    if self.mes == 12:
                        self.ano += 1
                        self.mes = 1
                    else:
                        self.mes += 1

                    self.dia = (iDiaFechamento != 99 and iDiaFechamento or self.dia) + prazo
                    dif = self.dia - self.getUltimoDiaDoMes()
                    if dif > 0:
                        self.dia = dif
                        self.mes += 1
                        if self.mes == 13:
                            self.mes = 1
                            self.ano += 1

                    _ano = str(self.ano)
                    _mes = str(self.mes)
                    _dia = str(self.dia)

                    if len(_mes) == 1:
                        _mes = '0' + _mes
                    if len(_dia) == 1:
                        _dia = '0' + _dia
                    self.data = _ano + '-' + _mes + '-' + _dia
                    self.__iniciaVariaveis()
                    self.__testaData()
                    totalDias = self.__calculoDFM()
                    return formatastring.formataString(str(_ano), 4, '0', 'E') \
                           + formatastring.formataString(str(_mes), 2, '0', 'E') \
                           + formatastring.formataString(str(_dia), 2, '0', 'E')
        try:
            totalDias = totalDias + int(prazo)
        except:
            self.__iniciaVariaveis()
            self.codErro = 6 #pPrazo invalido
            return -1
        if diasUteis == 'S':
            x = totalDias - (int(totalDias / 7) * 7)
            if x == 0: x = 7
            if prazo < 0:
                if x == 1: totalDias = totalDias + 1
                if x == 7: totalDias = totalDias + 2
            else:
                if x == 1: totalDias = totalDias - 2
                if x == 7: totalDias = totalDias - 1
        ano = int(totalDias / 365)
        x = totalDias - int(ano / 4)
        ano = int(x / 365) + 1
        x = totalDias - (((ano - 1) * 365) + (int((ano - 1) / 4)))

        mes = 0
        while True:
            mes = mes + 1
            dia = 1
            a = formatastring.formataString(str(ano), 4, '0', 'E') \
                + formatastring.formataString(str(mes), 2, '0', 'E') \
                + formatastring.formataString(str(dia), 2, '0', 'E')
            venc = sigDatas(a)
            ultimoDiaMesVenc = venc.getUltimoDiaDoMes()
            if ultimoDiaMesVenc >= x:
                break
            x = x - ultimoDiaMesVenc

        if x == 0:
            mes = mes - 1
            if mes != 0:
                a = formatastring.formataString(str(ano), 4, '0', 'E') \
                    + formatastring.formataString(str(mes), 2, '0', 'E') \
                    + formatastring.formataString(str(dia), 2, '0', 'E')
                venc = sigDatas(a)
                x = x + venc.getUltimoDiaDoMes()
        if mes == 0:
            mes = 12
            ano = ano - 1
            x = 31
        dia = x
        return formatastring.formataString(str(ano), 4, '0', 'E') \
               + formatastring.formataString(str(mes), 2, '0', 'E') \
               + formatastring.formataString(str(dia), 2, '0', 'E')

    def getNroDias(self):
        """ retorna a qtd de dias de uma data desde o dia 1/1/1 """
        if self.codErro != 0:
            return -1
        return self.totalDias

    def getNomeDoMes(self):
        """ retorna o nome do mes """
        if self.codErro != 0:
            return -1
        return self.nomeDoMes

    def get3NomeDoMes(self):
        """ retorna o nome do mes com 3 bytes """
        if self.codErro != 0:
            return -1
        return self.nome3DoMes

    def getDataOk(self):
        """ retorna True se a data estiver valida """
        if self.codErro != 0:
            return -1
        return True

    def getErroCod(self):
        """ retorna o codigo do erro qdo houver """
        return self.codErro

    def getErroDesc(self):
        """retorna da descricao do erro"""
        try:
            mensagem = self.listaDeErros[self.codErro]
        except:
            mensagem = "Codigo de mensagem nao cadastrado!"
        return mensagem


def calcUltimoDiaDoMes(data):
    """Calcula o ultimo dia do mes da data especificada"""
    d = sigDatas(data)
    ultimoDia = d.getUltimoDiaDoMes()
    return ultimoDia


def calcVencimento(data, prazo, tipo_prazo='DD', diaUtil='N', diaFechamento=0, feriados=[]):
    """Calcula o vencimento apartir da data 'data' e do prazo 'prazo' """
    d = sigDatas(data)
    venc = d.getCalculaPrazo(prazo, tipo_prazo, diaUtil, diaFechamento, feriados)
    return venc


def calcIdade(dataNascimento, dataHoje='hoje'):
    """ Calcula a idade com relacao
       dataNascimento = data de Nascimento desejada
       dataHoje data de referencia para calcular a idade se nao informada 
          sera considerada a data de hoje """
    idade = 0
    if str(dataHoje) == 'hoje':
        dataHoje = getDataDeHoje()
    dNasc = sigDatas(dataNascimento).getDataNoFormato('I')
    anoNasc = dNasc[:4]
    mesNasc = dNasc[4:6]
    diaNasc = dNasc[6:]
    dRefer = sigDatas(dataHoje).getDataNoFormato('I')
    anoRefer = dRefer[:4]
    mesRefer = dRefer[4:6]
    diaRefer = dRefer[6:]
    idade = int(anoRefer) - int(anoNasc)
    if int(mesRefer) < int(mesNasc):
        idade -= 1
    elif int(mesRefer) == int(mesNasc):
        if int(diaRefer) < int(diaNasc):
            idade -= 1
    return str(idade)


def calcDiferenca(dataInicio, dataFim):
    """ Calcula a diferenca em dias entre duas datas"""
    dInicio = sigDatas(dataInicio)
    dFim = sigDatas(dataFim)
    diasInicio = dInicio.getNroDias()
    if diasInicio == -1:
        return -1
    diasFim = dFim.getNroDias()
    if diasFim == -1:
        return -1
    diferenca = diasFim - diasInicio
    return diferenca


def months_between(end_date, start_date):
    """ MESES ENTRE DATAS """
    year_span = end_date.year - start_date.year
    month_span = end_date.month - start_date.month
    final_span = year_span * 12 + month_span
    if start_date.day - end_date.day < 0:
        if monthrange(end_date.year, end_date.month)[1] == end_date.day and \
                        monthrange(start_date.year, start_date.month)[1] == start_date.day:
            pass
        else:
            final_span -= 1
    return final_span + 2


def dataExtenso(data, imprimeSemana=False):
    y, m, d = (int(x) for x in data.split('-'))
    dat = date(y, m, d)
    mes = (
        'Janeiro', 'Fevereiro', 'Maro', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro',
        'Dezembro')
    Semana = ('Segunda', 'Tera', 'Quarta', 'Quinta', 'Sexta', 'Sbado', 'Domingo')
    nrosem = date.weekday(dat)
    return str(d) + ' ' + mes[m - 1] + ' ' + str(y) + ', ' + Semana[nrosem] if imprimeSemana else str(d) + ' ' + mes[
        m] + ' ' + str(y)


def calcVencimentos(data, listaPrazos, tipoPrazo='DD', diasUteis='N', diaFechamento=0):
    """Calcula vencimentos apartir de uma lista de prazos"""
    venc = []
    for prazo in listaPrazos:
        venc.append(calcVencimento(data, prazo, tipoPrazo, diasUteis, diaFechamento))
    return venc


def getDataDeHoje(formato='N', separador='/'):
    """retorna da data do sistema no formato especificado
      formatos: N - 13/05/2007
                I - 2007/05/13
                D - date
                S - 20070513 
                H - 17:09:20.74 -> horas"""
    x = str(datetime.now())
    xAno = formatastring.formataString(x[:4], 4, '0', 'E')
    xMes = formatastring.formataString(x[5:7], 2, '0', 'E')
    xDia = formatastring.formataString(x[8:10], 2, '0', 'E')
    if formato == 'I':
        return str(xAno + separador + xMes + separador + xDia)
    if formato == 'S':
        return str(xAno + xMes + xDia)
    if formato == 'H':
        if separador == '/':
            separador = ':'
        return (str(x[11:13]) + separador + str(x[14:16]) + separador + str(x[17:19]) + separador + str(x[20:22]))
    return str(xDia + separador + xMes + separador + xAno)


def getDataNoFormato(data, formato='N', separador='/'):
    """
    Retorna a data informada no formato especificado
      formatos: N - 13/05/2007
                I - 2007/05/13
                D - formato date
    """
    ddata = sigDatas(data)
    if ddata.dataOk and formato in ('N', 'I', 'D'):
        return ddata.getDataNoFormato(formato, 'S', separador)
    else:
        return False

def getDiffDatetime(datetimeI, datetimeF, resultado='D'):
    """
    Retorna a diferena entre duas datas no formato datetime
    @datetimeI = Data inicial formato YYYY-MM-DD HH:MM:SS
    @datetimeF = Data Finala formato YYYY-MM-DD HH:MM:SS
    @resultado = Formato do resultado desejado onde:
             A = Anos
             M = Meses
             D = Dias
             h = Horas
             m = minutos
             s = segundos
             T = lista com A, M, D, h , m , s
    O retorno pode ser um inteiro ou uma lista de inteiros conforme o parametro resultado
    Se s parametros estiverem errados ou no for possivel a diferena, retorna False
    """
    res = False
    try:
        _dataI = datetimeI[:10]
        _dataF = datetimeF[:10]
        _diffDias = calcDiferenca(_dataI, _dataF)
        _resAnos = int(_diffDias / 365)
        _resMes = int(_diffDias / 30)
        _resDias = _diffDias
        c = datetime.strptime(datetimeF, '%Y-%m-%d %H:%M:%S') - datetime.strptime(datetimeI, '%Y-%m-%d %H:%M:%S')
        _resSegundos = c.seconds + (_resDias * 86400)
        _resMinutos = (c.seconds / 60) + (_resDias * 1440)
        _resHoras = (c.seconds / 60 / 60) + (_resDias * 24)
        if resultado == 'A':
            res = _resAnos
        elif resultado == 'M':
            res = _resMes
        elif resultado == 'D':
            res = _resDias
        elif resultado == 'h':
            res = _resHoras
        elif resultado == 'm':
            res = _resMinutos
        elif resultado == 's':
            res = _resSegundos
        elif resultado == 'T':
            res = (_resAnos, _resMes, _resDias, _resHoras, _resMinutos, _resSegundos)
    except:
        pass
    return res

hoje = getDataDeHoje()
hoje_I = getDataDeHoje('I')
horas = getDataDeHoje('H')

"""
# Tetes
if __name__ == '__main__':
    print 'DFM'
    print "calcVencimento('20-04-2013', 10, 'DFM', 'N', 25)", calcVencimento('20-04-2013', 10, 'DFM', 'N', 25)
    print "calcVencimento('26-04-2013', 10, 'DFM', 'N', 25)", calcVencimento('26-04-2013', 10, 'DFM', 'N', 25)
    print 'DFQ'
    print "calcVencimento('10-04-2013', 10, 'DFQ', 'N', 12)", calcVencimento('10-04-2013', 10, 'DFQ', 'N', 12)
    print "calcVencimento('13-04-2013', 10, 'DFQ', 'N', 12)", calcVencimento('13-04-2013', 10, 'DFQ', 'N', 12)
    print "calcVencimento('25-04-2013', 10, 'DFQ', 'N', 12)", calcVencimento('25-04-2013', 10, 'DFQ', 'N', 12)
    print "calcVencimento('28-04-2013', 10, 'DFQ', 'N', 12)", calcVencimento('28-04-2013', 10, 'DFQ', 'N', 12)
    print 'DFD'
    print "calcVencimento('05-04-2013', 05, 'DFD', 'N', 08)", calcVencimento('05-04-2013', 05, 'DFD', 'N', 8)
    print "calcVencimento('09-04-2013', 05, 'DFD', 'N', 08)", calcVencimento('09-04-2013', 05, 'DFD', 'N', 8)
    print "calcVencimento('15-04-2013', 05, 'DFD', 'N', 08)", calcVencimento('15-04-2013', 05, 'DFD', 'N', 8)
    print "calcVencimento('19-04-2013', 05, 'DFD', 'N', 08)", calcVencimento('19-04-2013', 05, 'DFD', 'N', 8)
    print "calcVencimento('25-04-2013', 05, 'DFD', 'N', 08)", calcVencimento('25-04-2013', 05, 'DFD', 'N', 8)
    print "calcVencimento('29-04-2013', 05, 'DFD', 'N', 08)", calcVencimento('29-04-2013', 05, 'DFD', 'N', 8)
    print 'DFS'
    print "calcVencimento('02-04-2013', 02, 'DFS', 'N', 04)", calcVencimento('02-04-2013', 02, 'DFS', 'N', 4)
    print "calcVencimento('05-04-2013', 02, 'DFS', 'N', 04)", calcVencimento('05-04-2013', 02, 'DFS', 'N', 4)
    print "calcVencimento('09-04-2013', 02, 'DFS', 'N', 04)", calcVencimento('09-04-2013', 02, 'DFS', 'N', 4)
    print "calcVencimento('12-04-2013', 02, 'DFS', 'N', 04)", calcVencimento('12-04-2013', 02, 'DFS', 'N', 4)
    print "calcVencimento('16-04-2013', 02, 'DFS', 'N', 04)", calcVencimento('16-04-2013', 02, 'DFS', 'N', 4)
    print "calcVencimento('19-04-2013', 02, 'DFS', 'N', 04)", calcVencimento('19-04-2013', 02, 'DFS', 'N', 4)
    print "calcVencimento('23-04-2013', 02, 'DFS', 'N', 04)", calcVencimento('23-04-2013', 02, 'DFS', 'N', 4)
    print "calcVencimento('26-04-2013', 02, 'DFS', 'N', 04)", calcVencimento('26-04-2013', 02, 'DFS', 'N', 4)
"""
